Bug 22893 - KMS Intel graphics incompatible with RandR scaling feature
KMS Intel graphics incompatible with RandR scaling feature
Status: RESOLVED FIXED
Product: xorg
Classification: Unclassified
Component: Driver/intel
git
Other All
: high major
Assigned To: Keith Packard
Xorg Project Team
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2009-07-22 11:39 UTC by Guy Lunardi
Modified: 2009-07-27 09:29 UTC (History)
8 users (show)

See Also:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Guy Lunardi 2009-07-22 11:39:47 UTC
With KMS enabled the RandR scaling feature does not function properly.


On a 1024x600 display, running xrandr --output LVDS --scale 1x1.28 should
result in a 1024x768 resolution displayed on the screen.


This works fine if you disable KMS at kernel startup time.

Initially reported on SUSE Linux Enterprise Desktop 11. Reproduced on Moblin v2.0 beta (July 10th build), SUSE Edition of Moblin.

Also tested against the latest git release and the problem still seems present.

To reproduce:
On a system with latest Xorg git + kernel with KMS enabled
Run xrandr --output LVDS --scale 1x1.28 
The scaling does NOT happen.

To make it work:
On the same system, place i915.modeset=0 (or disable KMS in some other way)
Run xrandr --output LVDS --scale 1x1.28 
The scaling does happen. Of course performances are bad.
Comment 1 Guy Lunardi 2009-07-22 11:45:37 UTC
Ouput of xrandr before running "xrandr --output LVDS --scale 1x1.28":

Screen 0: minimum 320 x 200, current 1024 x 600, maximum 2048 x 2048
VGA1 disconnected (normal left inverted right x axis y axis)
LVDS1 connected 1024x600+0+0 (normal left inverted right x axis y axis) 223mm x 125mm
   1024x600       59.9*+
   800x600        60.3  
   640x480        59.9 



Ouput of xrandr after running "xrandr --output LVDS --scale 1x1.28":

Screen 0: minimum 320 x 200, current 1024 x 768, maximum 2048 x 2048
VGA1 disconnected (normal left inverted right x axis y axis)
LVDS1 connected 1024x600+0+0 (normal left inverted right x axis y axis) 223mm x 125mm
   1024x600       59.9*+
   800x600        60.3  
   640x480        59.9

the screen does get resized to 1024x768 but not scaling is taking place.

No external display is ever attached (only LVDS is used)
Comment 2 Guy Lunardi 2009-07-22 11:47:22 UTC
Very basic xorg.conf (nothing in it). Here is the content of the file:

        Section "Device"
                Identifier      "Builtin Default intel Device 0"
                Driver  "intel"
        EndSection
        Section "Screen"
                Identifier      "Builtin Default intel Screen 0"
                Device  "Builtin Default intel Device 0"
        EndSection
        Section "Device"
                Identifier      "Builtin Default vesa Device 0"
                Driver  "vesa"
        EndSection
        Section "Screen"
                Identifier      "Builtin Default vesa Screen 0"
                Device  "Builtin Default vesa Device 0"
        EndSection
        Section "ServerLayout"
                Identifier      "Builtin Default Layout"
                Screen  "Builtin Default intel Screen 0"
                Screen  "Builtin Default vesa Screen 0"
        EndSection

Section "ServerFlags"
  Option       "AllowMouseOpenFail" "on"
  Option       "ZapWarning" "on"
EndSection
Comment 3 Guy Lunardi 2009-07-22 11:48:14 UTC
Output of lspci


/sbin/lspci
00:00.0 Host bridge: Intel Corporation Mobile 945GME Express Memory Controller Hub (rev 03)
00:02.0 VGA compatible controller: Intel Corporation Mobile 945GME Express Integrated Graphics Controller (rev 03)
00:02.1 Display controller: Intel Corporation Mobile 945GM/GMS/GME, 943/940GML Express Integrated Graphics Controller (rev 03)
00:1b.0 Audio device: Intel Corporation 82801G (ICH7 Family) High Definition Audio Controller (rev 02)
00:1c.0 PCI bridge: Intel Corporation 82801G (ICH7 Family) PCI Express Port 1 (rev 02)
00:1c.2 PCI bridge: Intel Corporation 82801G (ICH7 Family) PCI Express Port 3 (rev 02)
00:1d.0 USB Controller: Intel Corporation 82801G (ICH7 Family) USB UHCI Controller #1 (rev 02)
00:1d.1 USB Controller: Intel Corporation 82801G (ICH7 Family) USB UHCI Controller #2 (rev 02)
00:1d.2 USB Controller: Intel Corporation 82801G (ICH7 Family) USB UHCI Controller #3 (rev 02)
00:1d.3 USB Controller: Intel Corporation 82801G (ICH7 Family) USB UHCI Controller #4 (rev 02)
00:1d.7 USB Controller: Intel Corporation 82801G (ICH7 Family) USB2 EHCI Controller (rev 02)
00:1e.0 PCI bridge: Intel Corporation 82801 Mobile PCI Bridge (rev e2)
00:1f.0 ISA bridge: Intel Corporation 82801GBM (ICH7-M) LPC Interface Bridge (rev 02)
00:1f.2 IDE interface: Intel Corporation 82801GBM/GHM (ICH7 Family) SATA IDE Controller (rev 02)
00:1f.3 SMBus: Intel Corporation 82801G (ICH7 Family) SMBus Controller (rev 02)
02:00.0 Ethernet controller: Atheros Communications Inc. AR242x 802.11abg Wireless PCI Express Adapter (rev 01)
03:00.0 Ethernet controller: Marvell Technology Group Ltd. 88E8040 PCI-E Fast Ethernet Controller (rev 13)

Comment 4 Guy Lunardi 2009-07-22 11:50:47 UTC
This issue was noted on several Intel Atom-based netbooks: Lenovo S9e, Acer Aspire One, Samsung N120 and HP NC2140.
Comment 5 Gordon Jin 2009-07-23 01:09:05 UTC
Jesse, is this a missing feature in KMS? If so, is this on your todo list?
Comment 6 Jesse Barnes 2009-07-23 08:36:50 UTC
No, this should be fixed now, but you may need a new X server.  Keith?
Comment 7 Stefan Dirsch 2009-07-23 08:38:50 UTC
(In reply to comment #6)
> No, this should be fixed now, but you may need a new X server.  Keith?

You mean newer than xorg-server 1.6.2?

Comment 8 Keith Packard 2009-07-23 10:52:30 UTC
I don't know what happened, but it's not working for me either. It worked briefly a few months ago...
Comment 9 Keith Packard 2009-07-26 13:59:33 UTC
Ok, the necessary patches didn't get into X server 1.6.2 or xf86-video-intel 2.8.0

I've pushed the (trivial) patch to xf86-video-intel and cherry-picked the patches to server-1.6-branch.

I'll do a 1.6.3 release and ask Carl to consider a 2.8.1 release so we can get 'official' versions of the necessary bits released.
Comment 10 Guy Lunardi 2009-07-27 09:29:22 UTC
(In reply to comment #9)
 
> I've pushed the (trivial) patch to xf86-video-intel and cherry-picked the
> patches to server-1.6-branch.
Thank you very much Keith. David is now trying to take these. Ideally we will be able to take your 1.6.3 release.

Best, -Guy